// program called on each simulation trial
program simstep , rclass

// scalar rsim = 1		// what is this?
scalar ntrial = ntrial + 1
if noPvalsim == 0  {
	// generate exponential response times using tilde fit params
	replace _t = -log(uniform()) * scale_til_data
	
	// make this dataset have the given censoring config 
	// by sorting it within strata and then replacing _d by _d_original
	sort $str_var _t
	svmat _d_orig   			// puts matrix _d_orig into a variable
								// named _d_orig1
	replace _d = _d_orig1		
	drop _d_orig1
	// have cens config now, but need to decide whom is censored
	mata: do_cens()	// creates censoring according to _d
   
    quietly: stcox $V_all , nohr strata($str_var)			// fit full model 
	// get things from this fit 
	mat beta_hat_trial = e(b)'
	scalar psi_hat_trial = beta_hat_trial[1,1]
	scalar llik_full_trial = e(ll)

	quietly: stcox $V_np , nohr offset(ofstvar)	strata($str_var)  // fit hyp model
												// ofstvar was computed in coxsim.ado 
	scalar llik_hyp_trial = e(ll)
	scalar sign = (-1) ^ ( psi_hat_trial < psihyp )
	scalar rvalcalc = sign * sqrt( 2 * (llik_full_trial - llik_hyp_trial) ) 
	}
else {
	scalar rvalcalc = 0
	} 
return scalar rval = rvalcalc  		// return r-value in r( ) 

if (noSkov == 0) & (ntrial <= nskov)  {
	// Skovgaard simulations (data under hat model now)
	replace _t = -log(uniform()) * scale_hat_data
	// make this dataset have the given censoring config 
	// by sorting it within strata and then replacing _d by _d_original
	sort $str_var _t
	svmat _d_orig   			// puts matrix _d_orig into a variable
								// named _d_orig1
	replace _d = _d_orig1		
	drop _d_orig1
	// have cens config now, but need to decide whom is censored
	mata: do_cens()	// creates censoring times _t according to _d

	mata: get_X()  // for later use in functions, _d is obtained separately
   
	mata: do_score_calcs()
	mata: do_accum()
	}
end

 
